package org.nakedobjects.nos.remote.command;

import org.nakedobjects.noa.security.Session;
import org.nakedobjects.noa.util.ByteEncoder;
import org.nakedobjects.nof.reflect.remote.data.Distribution;


public class AuthoriseUsability extends AbstractRequest {
    private static final long serialVersionUID = 1L;
    private final String data;

    public AuthoriseUsability(final Session session, final String data) {
        super(session);
        this.data = data;
    }

    protected void doEncode(ByteEncoder encoder) {}

    public void execute(Distribution distribution) {
        setResponse(new Boolean(distribution.authoriseUsability(session, data)));
    }

    public boolean getAuthorised() {
        return ((Boolean) response).booleanValue();
    }
}
