package org.nakedobjects.nos.remote.command;

import org.nakedobjects.noa.security.Session;
import org.nakedobjects.noa.util.ByteDecoder;
import org.nakedobjects.noa.util.ByteEncoder;
import org.nakedobjects.nof.reflect.remote.data.Distribution;
import org.nakedobjects.nof.reflect.remote.data.IdentityData;


public class OidForService extends AbstractRequest {
    private static final long serialVersionUID = 1L;
    private final String id;

    /**
     * provided for serialization only!
     */
    public OidForService() {
        super((Session) null);
        id = null;
    }
    

    public OidForService(ByteDecoder decoder) {
        super(decoder);
        id = decoder.getString();
    }

    protected void doEncode(final ByteEncoder encoder) {
        encoder.add(id);
    }
    
    public OidForService(Session session, String id) {
        super(session);
        this.id = id;
    }

    public void execute(Distribution distribution) {
        response = distribution.oidForService(session, id);
    }

    public IdentityData getData() {
        return (IdentityData) response;
    }

}

// Copyright (c) Naked Objects Group Ltd.
