package org.nakedobjects.nos.remote.command;

import org.nakedobjects.noa.security.Session;
import org.nakedobjects.noa.util.ByteDecoder;
import org.nakedobjects.noa.util.ByteEncoder;
import org.nakedobjects.nof.reflect.remote.data.Distribution;
import org.nakedobjects.nof.reflect.remote.data.IdentityData;
import org.nakedobjects.nof.reflect.remote.data.ObjectData;
import org.nakedobjects.nof.reflect.remote.data.ValueData;


public class SetValue extends AbstractRequest {
    private static final long serialVersionUID = 1L;
    private final String fieldIdentifier;
    private final ValueData value;
    private final IdentityData target;

    public SetValue(final Session session, final String fieldIdentifier, final IdentityData target, final ValueData value) {
        super(session);
        this.fieldIdentifier = fieldIdentifier;
        this.target = target;
        this.value = value;
    }

    public SetValue(ByteDecoder decoder) {
        super(decoder);
        fieldIdentifier = decoder.getString();
        target = (IdentityData) decoder.getObject();
        value = (ValueData) decoder.getObject();
    }

    protected void doEncode(final ByteEncoder encoder) {
        encoder.add(fieldIdentifier);
        encoder.add(target);
        encoder.add(value);
    }

    public void execute(final Distribution distribution) {
        response = distribution.setValue(session, fieldIdentifier, target, value);
    }

    public ObjectData[] getChanges() {
        return (ObjectData[]) response;
    }
}
// Copyright (c) Naked Objects Group Ltd.
