package org.nakedobjects.nos.remote.command.java;

import org.nakedobjects.noa.adapter.Oid;
import org.nakedobjects.noa.adapter.Version;
import org.nakedobjects.nof.reflect.remote.data.ClientActionResultData;
import org.nakedobjects.nof.reflect.remote.data.CollectionData;
import org.nakedobjects.nof.reflect.remote.data.Data;
import org.nakedobjects.nof.reflect.remote.data.IdentityData;
import org.nakedobjects.nof.reflect.remote.data.NullData;
import org.nakedobjects.nof.reflect.remote.data.ObjectData;
import org.nakedobjects.nof.reflect.remote.data.ReferenceData;
import org.nakedobjects.nof.reflect.remote.data.ServerActionResultData;
import org.nakedobjects.nof.reflect.remote.data.ValueData;
import org.nakedobjects.nos.remote.command.DataFactory;


public class JavaDataFactory implements DataFactory {

    public CollectionData createCollectionData(
            final String collectionType,
            final String elementType,
            final Oid oid,
            final ReferenceData[] elements,
            final boolean hasAllElements, final Version version) {
        return new JavaCollectionData(oid, collectionType, elementType, elements, hasAllElements, version);
    }

    public NullData createNullData(final String type) {
        return new JavaNullData(type);
    }

    public ObjectData createObjectData(final String type, final Oid oid, final boolean hasCompleteData, final Version version) {
        return new JavaObjectData(oid, type, hasCompleteData, version);
    }

    public IdentityData createIdentityData(final String type, final Oid oid, final Version version) {
        return new JavaReferenceData(type, oid, version);
    }

    public ServerActionResultData createServerActionResultData(
            final Data result,
            final ObjectData[] updatesData,
            final ReferenceData[] disposed,
            final ObjectData persistedTarget,
            final ObjectData[] persistedParameters,
            final String[] messages,
            final String[] warnings) {
        return new JavaResult(result, updatesData, disposed, persistedTarget, persistedParameters, messages, warnings);
    }

    public ValueData createValueData(final String type, final String encodedValue) {
        return new JavaValueData(type, encodedValue);
    }

    public ClientActionResultData createClientActionResultData(
            final ReferenceData[] madePersistent,
            final Version[] changedVersion,
            ObjectData[] updates) {
        return new JavaClientResult(madePersistent, changedVersion, updates);
    }
}
// Copyright (c) Naked Objects Group Ltd.
