package org.nakedobjects.nos.remote.command.marshal;

import org.nakedobjects.noa.persist.InstancesCriteria;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.context.NakedObjectsContext;
import org.nakedobjects.nof.reflect.remote.data.CriteriaData;
import org.nakedobjects.nof.reflect.remote.data.ObjectEncoder;


public abstract class AbstractCriteriaEncoder implements CriteriaEncoding {

    public InstancesCriteria restore(final CriteriaData criteriaData, final ObjectEncoder encoder) {
        NakedObjectSpecification specification = NakedObjectsContext.getReflector().loadSpecification(criteriaData.getType());
        boolean includeSubclasses = criteriaData.includeSubclasses();
        return doRestore(specification, includeSubclasses, criteriaData, encoder);
    }

    protected abstract InstancesCriteria doRestore(
            NakedObjectSpecification specification,
            boolean includeSubclasses,
            CriteriaData criteriaData,
            ObjectEncoder encoder);
}

// Copyright (c) Naked Objects Group Ltd.
