package org.nakedobjects.nos.remote.command.marshal;

import org.nakedobjects.noa.persist.InstancesCriteria;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.persist.AllInstances;
import org.nakedobjects.nof.reflect.remote.data.CriteriaData;
import org.nakedobjects.nof.reflect.remote.data.ObjectEncoder;
import org.nakedobjects.nos.remote.command.java.AllInstancesCriteriaData;

public class AllInstancesEncoder extends AbstractCriteriaEncoder {

    public CriteriaData createData(InstancesCriteria criteria, ObjectEncoder objectEncoder) {
        return new AllInstancesCriteriaData((AllInstances) criteria);
    }
 
    protected InstancesCriteria doRestore(final NakedObjectSpecification specification, final boolean includeSubclasses, final CriteriaData criteriaData, ObjectEncoder encoder) {
        return new AllInstances(specification, includeSubclasses);
    }
    
    public Class getCriteriaClass() {
        return AllInstances.class;
    }    
}




// Copyright (c) Naked Objects Group Ltd.
