package org.nakedobjects.nos.remote.command.marshal;

import org.nakedobjects.noa.persist.InstancesCriteria;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.persist.TitleCriteria;
import org.nakedobjects.nof.reflect.remote.data.CriteriaData;
import org.nakedobjects.nof.reflect.remote.data.ObjectEncoder;
import org.nakedobjects.nos.remote.command.java.FindByTitleCriteriaData;

public class FindByTitleEncoder extends AbstractCriteriaEncoder {

    public CriteriaData createData(final InstancesCriteria criteria, ObjectEncoder objectEncoder) {
        return new FindByTitleCriteriaData((TitleCriteria) criteria);
    }
 
    protected InstancesCriteria doRestore(final NakedObjectSpecification specification, final boolean includeSubclasses, final CriteriaData criteriaData, ObjectEncoder encoder) {
        String title = ((FindByTitleCriteriaData) criteriaData).getTitle();
        return new TitleCriteria(specification, title , includeSubclasses);
    }
    
    public Class getCriteriaClass() {
        return TitleCriteria.class;
    }
}

// Copyright (c) Naked Objects Group Ltd.
