package org.nakedobjects.nos.remote.command.marshal;

import org.nakedobjects.noa.persist.InstancesCriteria;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.context.PerspectiveCriteria;
import org.nakedobjects.nof.reflect.remote.data.CriteriaData;
import org.nakedobjects.nof.reflect.remote.data.ObjectEncoder;
import org.nakedobjects.nos.remote.command.java.PerspectiveCriteriaData;


public class PerspectiveCriteriaEncoder extends AbstractCriteriaEncoder {

    public CriteriaData createData(final InstancesCriteria criteria, final ObjectEncoder encoder) {
        PerspectiveCriteria perspectiveCriteria = (PerspectiveCriteria) criteria;
        return new PerspectiveCriteriaData(perspectiveCriteria);
    }

    protected InstancesCriteria doRestore(
            final NakedObjectSpecification speciperspectiveCriteria,
            final boolean includeSubclasses,
            final CriteriaData criteriaData,
            final ObjectEncoder encoder) {
        String userName = ((PerspectiveCriteriaData) criteriaData).getUserName();
        return new PerspectiveCriteria(userName );
    }

    public Class getCriteriaClass() {
        return PerspectiveCriteria.class;
    }
}

// Copyright (c) Naked Objects Group Ltd.
