package org.nakedobjects.nos.remote.command.socket;

import org.nakedobjects.nof.core.conf.Configuration;
import org.nakedobjects.nof.core.context.NakedObjectsContext;
import org.nakedobjects.nof.core.util.NakedObjectConfiguration;


public class ConnectionProperties {
    private static final String DEFAULT_HOST = "localhost";
    private static final int DEFAULT_PORT = 9567;
    private static final String HOST_PROPERTY = "address";
    private static final String PORT_PROPERTY = "port";
    private static final String REMOTING_PROPERTY_BASE = Configuration.ROOT + "remoting.command.";

    public static int port() {
        NakedObjectConfiguration configuration = NakedObjectsContext.getConfiguration();
        return configuration.getInteger(REMOTING_PROPERTY_BASE + PORT_PROPERTY, DEFAULT_PORT);
    }

    public static String host() {
        NakedObjectConfiguration configuration = NakedObjectsContext.getConfiguration();
        return configuration.getString(REMOTING_PROPERTY_BASE + HOST_PROPERTY, DEFAULT_HOST);
    }
}

// Copyright (c) Naked Objects Group Ltd.
