package org.nakedobjects.nos.remote.command.socket;

import java.io.IOException;

import org.nakedobjects.noa.NakedObjectRuntimeException;
import org.nakedobjects.nof.reflect.remote.data.Distribution;
import org.nakedobjects.nos.remote.command.Request;


public abstract class ServerConnection {
    private Distribution server;

    public ServerConnection(final Distribution server) {
        this.server = server;
    }

    protected abstract Request awaitRequest() throws IOException;
    
    public Distribution getServer() {
        return server;
    }

    protected abstract void sendError(NakedObjectRuntimeException exception) throws IOException;

    protected abstract void sendResponse(Object response) throws IOException;

}
// Copyright (c) Naked Objects Group Ltd.
